Global sw = 830, sh = 649, cw, ch, minx#, maxx#, miny#, maxy#
Global randR#, randG#, randB#, cInc#
Const epsilon# = 0.00001

midx = (GadgetWidth(Desktop())-sw) Shr 1
midy = (GadgetHeight(Desktop())-sh) Shr 1
Dim polyX#(1440),polyY#(1440),nodeX%(1440),clr%(5,2),gr%(0,0),parms#(17)
SeedRnd MilliSecs()

ss = CreateWindow("Super Shapes Exploration Kit",midx,midy,sw,sh,0,5)

;Assign ID to 'root' menu for the window created.
;All subsequent menus must be attached to this root menu ID
menu=WindowMenu(ss) 
menuFile = CreateMenu("File",0,menu)
CreateMenu("Load Super Shape Settings...",1,menuFile)
CreateMenu("Save Super Shape Settings...",2,menuFile)
CreateMenu("",3,menuFile)
CreateMenu("Load Image...",4,menuFile)
CreateMenu("Save Image...",5,menuFile)
CreateMenu("",6,menuFile)
CreateMenu("Exit",7,menuFile)
menuHelp = CreateMenu("Help",8,menu)
CreateMenu("Help",9,menuHelp)
CreateMenu("About",10,menuHelp)

CreateLabel("The Super Shape Formula",650,4,160,15,ss,0)
stx2 = CreateLabel("Super Shape Parameters", 650,88,120,15,ss,0)
stx3 = CreateLabel("a",660,103,10,15,ss,0)
tbx1 = CreateTextField(630,118,70,20,ss)
stx4 = CreateLabel("b",743,103,10,15,ss,0)
tbx2 = CreateTextField(713,118,70,20,ss)
stx5 = CreateLabel("m",660,143,15,15,ss,0)
tbx3 = CreateTextField(630,158,70,20,ss)
stx6 = CreateLabel("n1",742,143,15,15,ss,0)
tbx4 = CreateTextField(713,158,70,20,ss)
stx7 = CreateLabel("n2",658,183,16,15,ss,0)
tbx5 = CreateTextField(630,198,70,20,ss)
stx8 = CreateLabel("n3",742,183,16,15,ss,0)
tbx6 = CreateTextField(713,198,70,20,ss)
stx9 = CreateLabel("Angle",621,230,50,15,ss,0)
tbx7 = CreateTextField(610,245,50,20,ss)
stx10= CreateLabel("Pen Size",684,230,50,15,ss,0)
tbx8 = CreateTextField(682,245,50,20,ss)
stx11= CreateLabel("Scale",764,230,50,15,ss,0)
tbx9 = CreateTextField(754,245,50,20,ss)
btn1 = CreateButton("Pen Color",610,275,70,20,ss)
btn2 = CreateButton("Fill Color",713,275,70,20,ss)
btn3 = CreateButton("Background Color",640,305,100,20,ss)
stx12= CreateLabel("Cycle Selection",610,335,100,15,ss,0)
cbx1 = CreateComboBox(610,350,120,20,ss)
AddGadgetItem cbx1,"Single Cycle"	;index = 0
AddGadgetItem cbx1,"Multi-Cycle"	;index = 1
stx13= CreateLabel("Cycles",740,335,50,15,ss,0)
tbx10= CreateTextField(740,350,65,20,ss)
stx14= CreateLabel("Fill Mode Selection",610,380,150,15,ss,0)
cbx2 = CreateComboBox(610,395,200,20,ss)
AddGadgetItem cbx2,"No Fill"				;index = 0
AddGadgetItem cbx2,"Single Color Fill"		;index = 1
AddGadgetItem cbx2,"Radial Gradient Fill"	;index = 2
AddGadgetItem cbx2,"Plasma Fill"			;index = 3


stx15= CreateLabel("Gradient Fill Colors",660,425,120,15,ss,0)
btn4 = CreateButton("Gradient Color 1",635,440,128,20,ss)
btn5 = CreateButton("Gradient Color 2",635,465,128,20,ss)
btn6 = CreateButton("Draw Super Shape",635,500,150,20,ss)
btn7 = CreateButton("Clear Canvas",635,525,150,20,ss)
btn8 = CreateButton("Exit",635,570,150,20,ss)

cw = 600
ch = 600
can1 = CreateCanvas(0,0,cw,ch,ss)
canf = CreateCanvas(610,20,200,60,ss)
canpc = CreateCanvas(682,275,20,20,ss)
canfc = CreateCanvas(785,275,20,20,ss)
canbk = CreateCanvas(743,305,20,20,ss)
canc1 = CreateCanvas(765,440,20,20,ss)
canc2 = CreateCanvas(765,465,20,20,ss)

formula = LoadImage("formula.png")
SetBuffer CanvasBuffer(canf)
DrawBlock formula,0,0
FlipCanvas(canf)
splash = LoadImage("Splash.jpg")
SetBuffer CanvasBuffer(can1)
DrawBlock splash,0,0
FlipCanvas(can1)
FreeImage splash

UpdateWindowMenu ss
Local a#,b#,m#,n1#,n2#,n3#,ang#,scale#,cycles#
Local penSize%

;Place default values for text boxes
SetGadgetText tbx1,"1":   a=1.0			; 'a' value
SetGadgetText tbx2,"0.6": b=0.6			; 'b' value
SetGadgetText tbx3,"30":  m=30.0		; 'm' value
SetGadgetText tbx4,"35":  n1=35.0		; 'n1' value
SetGadgetText tbx5,"1.5": n2=1.5		; 'n2' value
SetGadgetText tbx6,"19":  n3=19.0		; 'n3' value
SetGadgetText tbx7,"0":   ang=0.0		; angle value
SetGadgetText tbx8,"3":   penSize=3		; pen size
SetGadgetText tbx9,"280": scale=280.0	; scale value
SetGadgetText tbx10,"1":  cycles=1.0	; number of cycles
;Set combo-box default values
SelectGadgetItem cbx1, 0	;select Single Cycle Mode
SelectGadgetItem cbx2, 0	;select No Fill
;set default pen color
clr(1,0)=255:clr(1,1)=255:clr(1,2)=255
inkbox(clr(1,0),clr(1,1),clr(1,2),CanvasBuffer(canpc))
FlipCanvas(canpc)
;set default fill color
clr(2,0)=128:clr(2,1)=128:clr(2,2)=192
inkbox(clr(2,0),clr(2,1),clr(2,2),CanvasBuffer(canfc))
FlipCanvas(canfc)
;set default background color
inkbox(clr(3,0),clr(3,1),clr(3,2),CanvasBuffer(canbk))
FlipCanvas(canbk)
;set default gradient color 1
clr(4,0)=0:clr(4,1)=0:clr(4,2)=128
inkbox(clr(4,0),clr(4,1),clr(4,2),CanvasBuffer(canc1))
FlipCanvas(canc1)
;set default gradient color 2
clr(5,0)=140:clr(5,1)=198:clr(5,2)=255
inkbox(clr(5,0),clr(5,1),clr(5,2),CanvasBuffer(canc2))
FlipCanvas(canc2)

; Poll for all pertinent events
Repeat
	eid = WaitEvent()
.gadgetEvents
	Select eid
		;poll for gadget event
		Case $401
			esrc = EventSource()
			Select esrc
				Case tbx1	;a value
					a = TextFieldText(tbx1)
					If Abs(a)<epsilon Then a=1.0
				Case tbx2	;b value
					b = TextFieldText(tbx2)
					If Abs(b)<epsilon Then b=1.0
				Case tbx3	;m value
					m = TextFieldText(tbx3)
				Case tbx4	;n1 value
					n1 = TextFieldText(tbx4)
				Case tbx5	;n2 value
					n2 = TextFieldText(tbx5)
				Case tbx6	;n3 value
					n3 = TextFieldText(tbx6)
				Case tbx7	;angle
					ang = TextFieldText(tbx7)
				Case tbx8	;pen size
					penSize = TextFieldText(tbx8)
				Case tbx9	;scale
					scale = TextFieldText(tbx9)
				Case tbx10	;number of cycles
					cycles = TextFieldText(tbx10)
					If Abs(cycles)<epsilon Then cycles=1.0
				Case cbx1	;cycle mode
					mCycle = SelectedGadgetItem(cbx1) 	;0=single cycle 1=multi-cycle
					If mCycle=0 Then
						SetGadgetText tbx10,"1"
						cycles=1.0
					End If
				Case cbx2	;fill mode
					;0=no fill 1=single color 2=grad fill 3=plasma
					fMode = SelectedGadgetItem(cbx2)
				Case btn1	;pen color
					penResult = RequestColor(clr(1,0),clr(1,1),clr(1,2))
					If penResult = 1 Then
						clr(1,0)=RequestedRed()
						clr(1,1)=RequestedGreen()
						clr(1,2)=RequestedBlue()
						inkbox(clr(1,0),clr(1,1),clr(1,2),CanvasBuffer(canpc))
						FlipCanvas(canpc)
					End If
				Case btn2	;fill color
					fillResult = RequestColor(clr(2,0),clr(2,1),clr(2,2))
					If fillResult = 1 Then
						clr(2,0)=RequestedRed()
						clr(2,1)=RequestedGreen()
						clr(2,2)=RequestedBlue()
						inkbox(clr(2,0),clr(2,1),clr(2,2),CanvasBuffer(canfc))
						FlipCanvas(canfc)
					End If
				Case btn3	;background color
					bkndResult = RequestColor(clr(3,0),clr(3,1),clr(3,2))
					If bkndResult = 1 Then
						clr(3,0)=RequestedRed()
						clr(3,1)=RequestedGreen()
						clr(3,2)=RequestedBlue()
						inkbox(clr(3,0),clr(3,1),clr(3,2),CanvasBuffer(canbk))
						FlipCanvas(canbk)
						SetBuffer(CanvasBuffer(can1))
						ClsColor clr(3,0),clr(3,1),clr(3,2)
						Cls
						FlipCanvas(can1)
					End If
				Case btn4	;gradient color 1
					c1Result = RequestColor(clr(4,0),clr(4,1),clr(4,2))
					If c1Result = 1 Then
						clr(4,0)=RequestedRed()
						clr(4,1)=RequestedGreen()
						clr(4,2)=RequestedBlue()
						inkbox(clr(4,0),clr(4,1),clr(4,2),CanvasBuffer(canc1))
						FlipCanvas(canc1)
					End If
				Case btn5	;gradient color 2
					c2Result = RequestColor(clr(5,0),clr(5,1),clr(5,2))
					If c2Result = 1 Then
						clr(5,0)=RequestedRed()
						clr(5,1)=RequestedGreen()
						clr(5,2)=RequestedBlue()
						inkbox(clr(5,0),clr(5,1),clr(5,2),CanvasBuffer(canc2))
						FlipCanvas(canc2)
					End If
				Case btn6	;draw ss
					SetBuffer(CanvasBuffer(can1))
					Select fMode
						Case 0
							Color clr(1,0),clr(1,1),clr(1,2)
							ssnf(a,b,m,n1,n2,n3,ang,scale,penSize,cycles)
							FlipCanvas(can1)
						Case 1
							If mCycle=0 Then
								Color clr(2,0),clr(2,1),clr(2,2)
								vcount=sspf(a,b,m,n1,n2,n3,ang,scale,1) ;call polyfill
								Color clr(2,0),clr(2,1),clr(2,2)
								polyFill(vcount)
								drawPoly(vcount,clr(1,0),clr(1,1),clr(1,2),penSize)
								FlipCanvas(can1)
							Else
								Notify "Single Color Fill not available in Multi-Cycle mode"
							End If
						Case 2
							stps = Int(scale/2.0)+1
							clrGrad(stps, clr(4,0),clr(4,1),clr(4,2), clr(5,0),clr(5,1),clr(5,2))
							cc = 0
							For ii#=scale To 2.0 Step -2.0
								Color gr(cc,0),gr(cc,1),gr(cc,2)
								ssnf(a,b,m,n1,n2,n3,ang,ii,penSize,cycles)
								cc=cc+1
							Next
							FlipCanvas(can1)
						Case 3
							cTen# = 60.0
							If loadParmFlag = 0 Then
								cInc = 5.0 * Float(Rand(1,3))
								randR=Rnd(0.000001,0.999999)
								randG=Rnd(0.000001,0.999999)
								randB=Rnd(0.000001,0.999999)
							End If
							For ii#=scale To 2.0 Step -2.0
								rval%=Cos(randR*cTen)*127+128
								gval%=Cos(randG*cTen)*127+128
								bval%=Cos(randB*cTen)*127+128
								Color rval,gval,bval
								ssnf(a,b,m,n1,n2,n3,ang,ii,penSize,cycles)
								cTen=cTen+cInc
							Next
							loadParmFlag=0
							FlipCanvas(can1)							
					End Select
				Case btn7 	;clear canvas
					SetBuffer(CanvasBuffer(can1))
					ClsColor clr(3,0),clr(3,1),clr(3,2)
					Cls
					FlipCanvas(can1)
				Case btn8	;exit program
					FreeImage formula
					End
			End Select
			
		;poll for menu event
		Case $1001
			edata = EventData()
.menuEvents
			Select edata
				Case 1: Gosub loadparms	;load settings
				Case 2: Gosub saveparms	;save settings
				Case 4: loadImg(can1)	;load image
				Case 5	saveImg(can1)	;save image
				Case 7	Exit 			;exit program
				Case 9	;help
					q$=Chr(34)
					ie$ = q$+"C:\Program Files\Internet Explorer\iexplore.exe "+q$
					url$ = CurrentDir()+"Help.html"
					help$=ie$+url$
					ExecFile help$
				Case 10	;about
					q$=Chr(34)
					ie$ = q$+"C:\Program Files\Internet Explorer\iexplore.exe "+q$
					url$ = CurrentDir()+"About.html"
					about$=ie$+url$
					ExecFile about$
			End Select
		;poll for red X to close window
		Case $803
			Exit 
	End Select
Forever

FreeImage formula
End

Function loadImg(canvs)
	imgName$ = ""
	imgName$ = RequestFile("Load Image...","png;*.jpg;*.bmp",False)
	If imgName$ = "" Then
		Notify "Load Image Cancelled."
	Else
		pic = LoadImage(imgName$)
		If pic <> 0 Then
			SetBuffer(CanvasBuffer(canvs))
			DrawBlock pic,0,0
			FlipCanvas(canvs)
			FreeImage pic
		Else
			Notify imgName$+" not found."
		End If
	End If
End Function

Function saveImg(canvs)
	savName$ = ""
	savName$ = RequestFile("Save Image...","bmp",True)
	If savName$ = "" Then
		Notify "Save Image Cancelled."
	Else
		temp = CreateImage(cw,ch)
		SetBuffer(CanvasBuffer(canvs))
		GrabImage temp,0,0
		SaveImage temp,savName$
		Notify savName$+" saved."
		FreeImage temp
	End If
End Function


.loadparms
	loadName$ = ""
	loadName$ = RequestFile("Load Super Shapes Settings...","sss",False)
	If loadName$ = "" Then
		Notify "Load Settings Cancelled"
	Else
		fin = ReadFile(loadname$)
		z$=ReadLine(fin)
		a=Trim(word$(z$,1))	;a
		SetGadgetText(tbx1,Str(a))
		z$=ReadLine(fin)
		b=Trim(word$(z$,1))	;b
		SetGadgetText(tbx2,Str(b))
		z$=ReadLine(fin)
		m=Trim(word$(z$,1))	;m
		SetGadgetText(tbx3,Str(m))
		z$=ReadLine(fin)
		n1=Trim(word$(z$,1))	;n1
		SetGadgetText(tbx4,Str(n1))
		z$=ReadLine(fin)
		n2=Trim(word$(z$,1))	;n2
		SetGadgetText(tbx5,Str(n2))
		z$=ReadLine(fin)
		n3=Trim(word$(z$,1))  ;n3
		SetGadgetText(tbx6,Str(n3))
		z$=ReadLine(fin)
		ang=Trim(word$(z$,1))	;angle
		SetGadgetText(tbx7,Str(ang))
		z$=ReadLine(fin)
		penSize=Trim(word$(z$,1))	;penSize
		SetGadgetText(tbx8,Str(penSize))
		z$=ReadLine(fin)
		scale=Trim(word$(z$,1))	;scale
		SetGadgetText(tbx9,Str(scale))
		z$=ReadLine(fin)
		mCycle=Trim(word$(z$,1))	;cycle mode
		SelectGadgetItem(cbx1,mCycle)
		z$=ReadLine(fin)
		cycles=Trim(word$(z$,1))	;number of cycles
		SetGadgetText(tbx10,Str(cycles))
		z$=ReadLine(fin)
		fMode=Trim(word$(z$,1))	;fill mode
		SelectGadgetItem(cbx2,fMode)
		z$=ReadLine(fin)
		clr(1,0)=Trim(word$(z$,1,","))	;pen color
		clr(1,1)=Trim(word$(z$,2,","))
		clr(1,2)=Trim(word$(z$,3,","))
		inkbox(clr(1,0),clr(1,1),clr(1,2),CanvasBuffer(canpc))
		FlipCanvas(canpc)
		z$=ReadLine(fin)
		clr(2,0)=Trim(word$(z$,1,","))	;fill color
		clr(2,1)=Trim(word$(z$,2,","))
		clr(2,2)=Trim(word$(z$,3,","))
		inkbox(clr(2,0),clr(2,1),clr(2,2),CanvasBuffer(canfc))
		FlipCanvas(canfc)
		z$=ReadLine(fin)
		clr(3,0)=Trim(word$(z$,1,","))	;background color
		clr(3,1)=Trim(word$(z$,2,","))
		clr(3,2)=Trim(word$(z$,3,","))
		inkbox(clr(3,0),clr(3,1),clr(3,2),CanvasBuffer(canbk))
		FlipCanvas(canbk)
		z$=ReadLine(fin)
		clr(4,0)=Trim(word$(z$,1,","))	;gradient color 1
		clr(4,1)=Trim(word$(z$,2,","))
		clr(4,2)=Trim(word$(z$,3,","))
		inkbox(clr(4,0),clr(4,1),clr(4,2),CanvasBuffer(canc1))
		FlipCanvas(canc1)
		z$=ReadLine(fin)
		clr(5,0)=Trim(word$(z$,1,","))	;gradient color 2
		clr(5,1)=Trim(word$(z$,2,","))
		clr(5,2)=Trim(word$(z$,3,","))
		inkbox(clr(5,0),clr(5,1),clr(5,2),CanvasBuffer(canc2))
		FlipCanvas(canc2)
		If fMode = 3 Then	;Plasma settings
			z$=ReadLine(fin)
			randR=Trim(word$(z$,1,","))
			randG=Trim(word$(z$,2,","))
			randB=Trim(word$(z$,3,","))
			cInc =Trim(word$(z$,4,","))
		End If
	End If
	CloseFile fin
	SetBuffer(CanvasBuffer(can1))
	ClsColor clr(3,0),clr(3,1),clr(3,2)
	Cls
	Select fMode
		Case 0	;No Fill 
			Color clr(1,0),clr(1,1),clr(1,2)
			ssnf(a,b,m,n1,n2,n3,ang,scale,penSize,cycles)
			FlipCanvas(can1)
		Case 1	;Single Color Fill
			If mCycle=0 Then
				Color clr(2,0),clr(2,1),clr(2,2)
				vcount=sspf(a,b,m,n1,n2,n3,ang,scale,1) ;call polyfill
				Color clr(2,0),clr(2,1),clr(2,2)
				polyFill(vcount)
				drawPoly(vcount,clr(1,0),clr(1,1),clr(1,2),penSize)
				FlipCanvas(can1)
			Else
				Notify "Single Color Fill not available in Multi-Cycle mode"
			End If
		Case 2	;Gradient Fill
			stps = Int(scale/2.0)+1
			clrGrad(stps, clr(4,0),clr(4,1),clr(4,2), clr(5,0),clr(5,1),clr(5,2))
			cc = 0
			For ii#=scale To 2.0 Step -2.0
				Color gr(cc,0),gr(cc,1),gr(cc,2)
				ssnf(a,b,m,n1,n2,n3,ang,ii,penSize,cycles)
				cc=cc+1
			Next
			FlipCanvas(can1)
		Case 3
			cTen# = 60.0
			For ii#=scale To 2.0 Step -2.0
				rval%=Cos(randR*cTen)*127+128
				gval%=Cos(randG*cTen)*127+128
				bval%=Cos(randB*cTen)*127+128
				Color rval,gval,bval
				ssnf(a,b,m,n1,n2,n3,ang,ii,penSize,cycles)
				cTen=cTen+cInc
			Next
			FlipCanvas(can1)
	End Select
Return

.saveParms
saveName$=""
saveName$=RequestFile("Save Super Shapes Settings...","sss",True)
If saveName$ = "" Then
	Notify "Save Settings Cancelled."
Else
	pad$="            ";12 spaces
	fout = WriteFile(saveName$)
	z$ = Left(Trim(TextFieldText(tbx1))+pad$,12)
	WriteLine fout, z$+";a value"
	z$ = Left(Trim(TextFieldText(tbx2))+pad$,12)
	WriteLine fout, z$+";b value"
	z$ = Left(Trim(TextFieldText(tbx3))+pad$,12)
	WriteLine fout, z$+";m value"
	z$ = Left(Trim(TextFieldText(tbx4))+pad$,12)
	WriteLine fout, z$+";n1 value"
	z$ = Left(Trim(TextFieldText(tbx5))+pad$,12)
	WriteLine fout, z$+";n2 value"
	z$ = Left(Trim(TextFieldText(tbx6))+pad$,12)
	WriteLine fout, z$+";n3 value"
	z$ = Left(Trim(TextFieldText(tbx7))+pad$,12)
	WriteLine fout, z$+";Rotation Angle"
	z$ = Left(Trim(TextFieldText(tbx8))+pad$,12)
	WriteLine fout, z$+";Pen Size"
	z$ = Left(Trim(TextFieldText(tbx9))+pad$,12)
	WriteLine fout, z$+";Scaling Factor"
	z$ = Left(Trim(SelectedGadgetItem(cbx1))+pad$,12)
	WriteLine fout, z$+";0=Single Cycle 1=Multi-Cycle"
	z$ = Left(Trim(TextFieldText(tbx10))+pad$,12)
	WriteLine fout, z$+";Number of Cycles"
	z$ = Left(Trim(SelectedGadgetItem(cbx2))+pad$,12)
	WriteLine fout, z$+";0=No Fill 1=Single Color 2=Gradient Fill 3=Plasma Fill"
	z$ = Str(clr(1,0))+","+Str(clr(1,1))+","+Str(clr(1,2))+pad$
	WriteLine fout, Left(z$,12)+";Pen Color"
	z$ = Str(clr(2,0))+","+Str(clr(2,1))+","+Str(clr(2,2))+pad$
	WriteLine fout, Left(z$,12)+";Fill Color"
	z$ = Str(clr(3,0))+","+Str(clr(3,1))+","+Str(clr(3,2))+pad$
	WriteLine fout, Left(z$,12)+";Background Color"
	z$ = Str(clr(4,0))+","+Str(clr(4,1))+","+Str(clr(4,2))+pad$
	WriteLine fout, Left(z$,12)+";Gradient Color 1"
	z$ = Str(clr(5,0))+","+Str(clr(5,1))+","+Str(clr(5,2))+pad$
	WriteLine fout, Left(z$,12)+";Gradient Color 2"
	If Trim(SelectedGadgetItem(cbx2))=3 Then
		z$=Str$(randR)+","+Str$(randG)+","+Str$(randB)+","+Str(cInc)
		WriteLine(fout,z$+" ;Plasma fill settings")
	End If
	CloseFile fout
End If
Return

Function ssnf(a#, b#, m#, n1#, n2#, n3#, angle#, scale#, pen%, cycles#)
	;Super Shapes No Fill
	Local m4#, rca#, rsa#, t1#, t2#, fin#, phi#, sign#, r#, rx#, ry#, newx#, newy#
	Local cx%, cy%, offset%, nx%, ny%, oldx%, oldy%
	
	If pen > 1 Then offset = pen Shr 1
	cx=cw Shr 1 : cy=ch Shr 1
	m4 = m/4.0
	rca = Cos(angle) : 	rsa = Sin(angle)	
	fin = 360.0*cycles
	For phi = 0. To fin
		t1 = Cos(m4*phi) / a : t1 = Abs(t1) ^ n2
		t2 = Sin(m4*phi) / b : t2 = Abs(t2) ^ n3
		If n1<epsilon Then n1=epsilon ;avoid div by zero error
		r = (t1+t2) ^ (1.0/n1)
		If Abs(r) = 0. Then 
			newx = 0.
			newy = 0.
		Else
			r = 1./r
			rx = r*Cos(phi)
			ry = r*Sin(phi)
			newx = rca*rx-rsa*ry
			newy = rsa*rx+rca*ry
		End If
		nx = newx*scale + cx
		ny = newy*scale + cy
		If phi=0.0 Then
			If pen>1 Then
				Rect nx-offset,ny-offset,pen,pen,True
			Else
				Plot nx,ny
			End If
		Else
			If pen > 1 Then
				tLine(oldx, oldy, nx, ny, pen)
			Else
				Line(oldx, oldy, nx, ny)
			End If
		End If
		oldx = nx
		oldy = ny	
	Next
End Function


Function sspf(a#, b#, m#, n1#, n2#, n3#, angle#, scale#, pen%)
	;Super Shapes Poly Fill
	Local m4#, rca#, rsa#, t1#, t2#, phi#, sign#, r#, rx#, ry#, newx#, newy#
	Local cx%, cy%, offset%, nx%, ny%, oldx%, oldy%,vcount%
	
	If pen > 1 Then offset = pen Shr 1
	cx=cw Shr 1 : cy=ch Shr 1
	m4 = m/4.0
	rca = Cos(angle) : 	rsa = Sin(angle)
	minx=cw : maxx=-cw : miny=ch : maxy=-ch
	For phi = 0. To 360. ;Step .5
		t1 = Cos(m4*phi) / a : t1 = Abs(t1) ^ n2
		t2 = Sin(m4*phi) / b : t2 = Abs(t2) ^ n3
		If n1<epsilon Then n1=epsilon
		r = (t1+t2) ^ (1.0/n1)
		If Abs(r) = 0. Then 
			newx = 0.
			newy = 0.
		Else
			r = 1./r
			rx = r*Cos(phi)
			ry = r*Sin(phi)
			newx = rca*rx-rsa*ry
			newy = rsa*rx+rca*ry
		End If
		nx = newx*scale + cx
		ny = newy*scale + cy
		If nx<minx Then minx=nx
		If nx>maxx Then maxx=nx
		If ny<miny Then miny=ny
		If ny>maxy Then maxy=ny
		If phi=0.0 Then
			If pen>1 Then
				Rect nx-offset,ny-offset,pen,pen,True
			Else
				Plot nx,ny
			End If
		Else
			If pen > 1 Then
				tLine(oldx, oldy, nx, ny, pen)
			Else
				Line(oldx, oldy, nx, ny)
			End If
		End If
		polyX(vcount)=nx
		polyY(vcount)=ny
		oldx = nx
		oldy = ny
		vcount=vcount+1	
	Next
	Return (vcount-1)
End Function

Function inkbox(r,g,b,canBuff)
	SetBuffer canBuff
	ClsColor r,g,b
	Cls
	Color 0,0,0
	Rect 0,0,20,20,False
End Function

Function clrGrad(steps#, r1#,g1#,b1#, r2#,g2#,b2#)
	Local dr#,dg#,db#,smax#,incr#,incg#,incb#
	Dim gr%(steps,2)
	
	gr(0,0)=r1			;store first color in gr() array
	gr(0,1)=g1
	gr(0,2)=b1
	gr(steps-1,0)=r2	;store last color in gr() array
	gr(steps-1,1)=g2
	gr(steps-1,2)=b2
	dr = r2 - r1
	dg = g2 - g1
	db = b2 - b1
	smax = (steps-1)
	incr = dr/smax
	incg = dg/smax
	incb = db/smax
	For i = 1 To smax-1
		r1 = r1 + incr
		g1 = g1 + incg
		b1 = b1 + incb
		gr(i,0)=r1
		gr(i,1)=g1
		gr(i,2)=b1
	Next
End Function

Function drawPoly(numPoints%, r,g,b, penSize%)
	Local j%, i%

	;allow variable line width and color
	If penSize < 1 Then penSize = 1
	Color r,g,b
	;draw it!
	j = numPoints-1
	For i = 0 To numPoints-1
		If penSize > 1 Then 
			tLine(polyX(j), polyY(j), polyX(i), polyY(i), penSize )
		Else
			Line polyX(j), polyY(j), polyX(i), polyY(i)
		End If
		j=i
	Next
End Function

Function polyFill(numSides%)
	Local pixelY%, i%, j%, nodes%, b1%, b2%, b3%, b4%, temp%
	Local fpixY#, f1#, f2#, f3#
	
	For pixelY = minY To maxY
		nodes = 0
		j = numSides-1
		fpixY = Float(pixelY)
		;build node list
		For i = 0 To numSides-1
			b1 = polyY(i) < fpixY
			b2 = polyY(j) >= fpixY
			b3 = polyY(j) < fpixY
			b4 = polyY(i) >= fpixY
			If (b1 And b2) Or (b3 And b4) Then
				f1 = fpixY - polyY(i)
				f2 = polyY(j)-polyY(i)
				f3 = polyX(j)-polyX(i)
				nodeX(nodes) = Floor(f1/f2*f3+polyX(i))
				nodes = nodes + 1
			End If
			j = i
		Next
		;sort nodes
		i = 0
		While i < nodes-1
			If nodeX(i)>nodeX(i+1) Then
				temp = nodeX(i)
				nodeX(i) = nodeX(i+1)
				nodeX(i+1) = temp
				If i > 0 Then i = i - 1
			Else
				i = i + 1
			End If
		Wend
		;draw scanline(s)
		For i = 0 To nodes-1 Step 2
			If nodeX(i) <= maxX Then
				If nodeX(i+1) > minX Then
					If nodeX(i) < minX Then nodeX(i) = minX
					If nodeX(i+1) > maxX Then nodeX(i+1) = maxX
					Line nodeX(i),pixelY,nodeX(i+1),pixelY
				End If
			End If
		Next
	Next
End Function

Function tLine(x1%, y1%, x2%, y2%, penSize%)
;====================================   tLine   ========================
;== Parameters are:                                                   ==
;== x1%, y1%, x2%, y2%, penSize%                                      ==
;==                                                                   ==
;== x1%, y1% are the coords of the line origin                        ==
;== x2%, y2% are the coords of the line end point                     ==
;== penSize% is the thickness of line to be drawn  (1-100)            ==
;==                                                                   ==
;== BRESLINE.PAS - A general line drawing procedure.                  ==
;== By Mark Feldman                                                   ==
;==                                                                   ==
;== Source: http://www.gamedev.net/reference/articles/article767.asp  ==
;==                                                                   ==
;== Adapted for Blitz+ tLine function by Andy Amaya                   ==
;==                                                                   ==
;=======================================================================
	Local offset%, deltax%, deltay%, numRects%, d%
	Local dinc1%, dinc2%, xinc1%, xinc2%, yinc1%, yinc2%

	If penSize < 2 Then Line(x1, y1, x2, y2): Return
;	penSize is thickness to draw line
	offset = penSize Shr 1	;offset needed to place Rect correctly

;	Calculate deltax and deltay for initialization
	deltax = Abs(x2 - x1)
	deltay = Abs(y2 - y1)
 
;	Initialize all variables based on which is the independent variable
	If deltax >= deltay Then
;		x is the independent variable
		numRects = deltax + 1
		d = (deltay Shl 1) - deltax
		dinc1 = deltay Shl 1
		dinc2 = (deltay - deltax) Shl 1
		xinc1 = 1
		xinc2 = 1
		yinc1 = 0
		yinc2 = 1
	Else
;		y is the independent variable
		numRects = deltay + 1
		d = (deltax Shl 1) - deltay
		dinc1 = deltax Shl 1
		dinc2 = (deltax - deltay) Shl 1
		xinc1 = 0
		xinc2 = 1
		yinc1 = 1
		yinc2 = 1
	End If
;	Make sure x and y move in the right directions
	If x1 > x2 Then
		xinc1 = - xinc1
		xinc2 = - xinc2
	End If
	If y1 > y2 Then 
		yinc1 = - yinc1
		yinc2 = - yinc2
	End If
;	Start drawing at x, y
	x = x1 - offset
	y = y1 - offset
;	Draw the filled rects
	For i = 1 To numRects
		Rect x, y, penSize, penSize, True
		If d < 0 Then 
			d = d + dinc1
			x = x + xinc1
			y = y + yinc1
		Else
			d = d + dinc2
			x = x + xinc2
			y = y + yinc2
		End If
	Next
End Function

Function word$(string2Chk$, n, delimiter$=" ")
	;initialize local variables
	Local count% = 0
	Local findDelimiter% = 0
	Local position% = 1
	Local current$ = ""
	;'n' must be greater than zero
	;otherwise exit function and return null string
	If n > 0 Then
		;strip leading and trailing spaces
		string2Chk$  = Trim(string2Chk$)
		;find the word(s)
		Repeat
			;first check if the delimiter occurs in string2Chk$
			findDelimiter = Instr(string2Chk$,delimiter$,position)
			If findDelimiter <> 0 Then
				;extract current word in string2Chk$
				current$ = Mid$(string2Chk$,position,findDelimiter-position)
				;word extracted; increment counter
				count = count + 1
				;update the start position of the next pass
				position = findDelimiter + 1
				;if counter is same as n then exit loop
				If count = n Then findDelimiter = 0
			End If
		Until findDelimiter = 0
		;Special Case: only one word and no delimiter(s) or last word in string2Chk$
		If (count < n) And (position <= Len(string2Chk$)) Then
			current$ = Mid$(string2Chk$,position, Len(string2Chk$) - position+1)
			count = count + 1
			;looking for word that is beyond length of string2Chk$
			If count < n Then current$ = ""
		End If
	End If
	Return current$
End Function